import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoachCash, ThinkCoachCashParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询教练提现审核表
 */
export async function pageThinkCoachCash(params: ThinkCoachCashParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoachCash>>>(
    THINK_API_URL + '/think/think-coach-cash/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询教练提现审核表列表
 */
export async function listThinkCoachCash(params?: ThinkCoachCashParam) {
  const res = await request.get<ApiResult<ThinkCoachCash[]>>(
    THINK_API_URL + '/think/think-coach-cash',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加教练提现审核表
 */
export async function addThinkCoachCash(data: ThinkCoachCash) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cash',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改教练提现审核表
 */
export async function updateThinkCoachCash(data: ThinkCoachCash) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cash',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除教练提现审核表
 */
export async function removeThinkCoachCash(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cash/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除教练提现审核表
 */
export async function removeBatchThinkCoachCash(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cash/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询教练提现审核表
 */
export async function getThinkCoachCash(id: number) {
  const res = await request.get<ApiResult<ThinkCoachCash>>(
    THINK_API_URL + '/think/think-coach-cash/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
